Index: kernel/arch/riscv64/src/riscv64.c
===================================================================
--- kernel/arch/riscv64/src/riscv64.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/arch/riscv64/src/riscv64.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -40,5 +40,5 @@
 #include <arch/drivers/ucb.h>
 
-#include <halt.h>
+#include <func.h>
 #include <config.h>
 #include <errno.h>
@@ -143,10 +143,10 @@
 }
 
-errno_t memcpy_from_uspace(void *dst, const void *uspace_src, size_t size)
+int memcpy_from_uspace(void *dst, const void *uspace_src, size_t size)
 {
 	return EOK;
 }
 
-errno_t memcpy_to_uspace(void *uspace_dst, const void *src, size_t size)
+int memcpy_to_uspace(void *uspace_dst, const void *src, size_t size)
 {
 	return EOK;
Index: kernel/arch/sparc64/src/mm/sun4u/as.c
===================================================================
--- kernel/arch/sparc64/src/mm/sun4u/as.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/arch/sparc64/src/mm/sun4u/as.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -60,10 +60,10 @@
 }
 
-errno_t as_constructor_arch(as_t *as, unsigned int flags)
+int as_constructor_arch(as_t *as, unsigned int flags)
 {
 #ifdef CONFIG_TSB
 	uintptr_t tsb_base = frame_alloc(TSB_FRAMES, flags, TSB_SIZE - 1);
 	if (!tsb_base)
-		return ENOMEM;
+		return -1;
 
 	tsb_entry_t *tsb = (tsb_entry_t *) PA2KA(tsb_base);
@@ -74,5 +74,5 @@
 #endif
 	
-	return EOK;
+	return 0;
 }
 
@@ -88,5 +88,5 @@
 }
 
-errno_t as_create_arch(as_t *as, unsigned int flags)
+int as_create_arch(as_t *as, unsigned int flags)
 {
 #ifdef CONFIG_TSB
Index: kernel/arch/sparc64/src/mm/sun4v/as.c
===================================================================
--- kernel/arch/sparc64/src/mm/sun4v/as.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/arch/sparc64/src/mm/sun4v/as.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -63,10 +63,10 @@
 }
 
-errno_t as_constructor_arch(as_t *as, unsigned int flags)
+int as_constructor_arch(as_t *as, unsigned int flags)
 {
 #ifdef CONFIG_TSB
 	uintptr_t tsb_base = frame_alloc(TSB_FRAMES, flags, TSB_SIZE - 1);
 	if (!tsb_base)
-		return ENOMEM;
+		return -1;
 
 	tsb_entry_t *tsb = (tsb_entry_t *) PA2KA(tsb_base);
@@ -83,5 +83,5 @@
 #endif
 	
-	return EOK;
+	return 0;
 }
 
@@ -97,5 +97,5 @@
 }
 
-errno_t as_create_arch(as_t *as, unsigned int flags)
+int as_create_arch(as_t *as, unsigned int flags)
 {
 #ifdef CONFIG_TSB
@@ -103,5 +103,5 @@
 #endif
 	
-	return EOK;
+	return 0;
 }
 
Index: kernel/arch/sparc64/src/smp/sun4u/smp.c
===================================================================
--- kernel/arch/sparc64/src/smp/sun4u/smp.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/arch/sparc64/src/smp/sun4u/smp.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -106,6 +106,6 @@
 	waking_up_mid = mid;
 		
-	if (waitq_sleep_timeout(&ap_completion_wq, 1000000,
-	    SYNCH_FLAGS_NONE, NULL) == ETIMEOUT)
+	if (waitq_sleep_timeout(&ap_completion_wq, 1000000, SYNCH_FLAGS_NONE) ==
+	    ESYNCH_TIMEOUT)
 		log(LF_ARCH, LVL_NOTE, "%s: waiting for processor (mid = %" PRIu32
 		    ") timed out", __func__, mid);
Index: kernel/arch/sparc64/src/smp/sun4v/smp.c
===================================================================
--- kernel/arch/sparc64/src/smp/sun4v/smp.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/arch/sparc64/src/smp/sun4v/smp.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -43,5 +43,5 @@
 #include <config.h>
 #include <macros.h>
-#include <halt.h>
+#include <func.h>
 #include <stdbool.h>
 #include <stddef.h>
@@ -373,6 +373,6 @@
 #endif
 	
-	if (waitq_sleep_timeout(&ap_completion_wq, 10000000,
-	    SYNCH_FLAGS_NONE, NULL) == ETIMEOUT)
+	if (waitq_sleep_timeout(&ap_completion_wq, 10000000, SYNCH_FLAGS_NONE) ==
+	    ESYNCH_TIMEOUT)
 		printf("%s: waiting for processor (cpuid = %" PRIu64 ") timed out\n",
 		    __func__, cpuid);
Index: kernel/arch/sparc64/src/sun4v/md.c
===================================================================
--- kernel/arch/sparc64/src/sun4v/md.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/arch/sparc64/src/sun4v/md.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -35,5 +35,5 @@
 #include <debug.h>
 #include <panic.h>
-#include <halt.h>
+#include <func.h>
 #include <log.h>
 #include <str.h>
Index: kernel/genarch/include/genarch/drivers/am335x/ctrl_module.h
===================================================================
--- kernel/genarch/include/genarch/drivers/am335x/ctrl_module.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/genarch/include/genarch/drivers/am335x/ctrl_module.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -46,5 +46,5 @@
 typedef ioport32_t am335x_ctrl_module_t;
 
-static errno_t
+static int
 am335x_ctrl_module_clock_freq_get(am335x_ctrl_module_t *base, unsigned *freq)
 {
Index: kernel/genarch/include/genarch/drivers/am335x/timer.h
===================================================================
--- kernel/genarch/include/genarch/drivers/am335x/timer.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/genarch/include/genarch/drivers/am335x/timer.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -85,5 +85,5 @@
 } am335x_timer_t;
 
-extern errno_t am335x_timer_init(am335x_timer_t *timer, am335x_timer_id_t id,
+extern int am335x_timer_init(am335x_timer_t *timer, am335x_timer_id_t id,
     unsigned hz, unsigned srcclk_hz);
 extern void am335x_timer_intr_ack(am335x_timer_t *timer);
Index: kernel/genarch/src/ddi/ddi-bitmap.c
===================================================================
--- kernel/genarch/src/ddi/ddi-bitmap.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/genarch/src/ddi/ddi-bitmap.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -57,5 +57,5 @@
  *
  */
-errno_t ddi_iospace_enable_arch(task_t *task, uintptr_t ioaddr, size_t size)
+int ddi_iospace_enable_arch(task_t *task, uintptr_t ioaddr, size_t size)
 {
 	size_t elements = ioaddr + size;
@@ -120,5 +120,5 @@
  *
  */
-errno_t ddi_iospace_disable_arch(task_t *task, uintptr_t ioaddr, size_t size)
+int ddi_iospace_disable_arch(task_t *task, uintptr_t ioaddr, size_t size)
 {
 	size_t elements = ioaddr + size;
Index: kernel/genarch/src/ddi/ddi-dummy.c
===================================================================
--- kernel/genarch/src/ddi/ddi-dummy.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/genarch/src/ddi/ddi-dummy.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -48,5 +48,5 @@
  * @return EOK on success or an error code from errno.h.
  */
-errno_t ddi_iospace_enable_arch(task_t *task, uintptr_t ioaddr, size_t size)
+int ddi_iospace_enable_arch(task_t *task, uintptr_t ioaddr, size_t size)
 {
 	return 0;
@@ -63,5 +63,5 @@
  * @return EOK on success or an error code from errno.h.
  */
-errno_t ddi_iospace_disable_arch(task_t *task, uintptr_t ioaddr, size_t size)
+int ddi_iospace_disable_arch(task_t *task, uintptr_t ioaddr, size_t size)
 {
 	return 0;
Index: kernel/genarch/src/drivers/am335x/timer.c
===================================================================
--- kernel/genarch/src/drivers/am335x/timer.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/genarch/src/drivers/am335x/timer.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -84,5 +84,5 @@
 }
 
-errno_t
+int
 am335x_timer_init(am335x_timer_t *timer, am335x_timer_id_t id, unsigned hz,
     unsigned srcclk_hz)
Index: kernel/genarch/src/ofw/upa.c
===================================================================
--- kernel/genarch/src/ofw/upa.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/genarch/src/ofw/upa.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -38,5 +38,5 @@
 #include <genarch/ofw/ofw_tree.h>
 #include <genarch/ofw/upa.h>
-#include <halt.h>
+#include <func.h>
 #include <panic.h>
 #include <macros.h>
Index: kernel/generic/include/adt/bitmap.h
===================================================================
--- kernel/generic/include/adt/bitmap.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/include/adt/bitmap.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -37,6 +37,4 @@
 
 #include <stddef.h>
-#include <stdbool.h>
-#include <stdint.h>
 
 #define BITMAP_ELEMENT   8
@@ -83,5 +81,5 @@
 extern void bitmap_clear_range(bitmap_t *, size_t, size_t);
 
-extern bool bitmap_allocate_range(bitmap_t *, size_t, size_t, size_t, size_t,
+extern int bitmap_allocate_range(bitmap_t *, size_t, size_t, size_t, size_t,
     size_t *);
 extern void bitmap_copy(bitmap_t *, bitmap_t *, size_t);
Index: kernel/generic/include/cap/cap.h
===================================================================
--- kernel/generic/include/cap/cap.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/include/cap/cap.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -115,5 +115,5 @@
 
 extern void caps_init(void);
-extern errno_t caps_task_alloc(struct task *);
+extern int caps_task_alloc(struct task *);
 extern void caps_task_free(struct task *);
 extern void caps_task_init(struct task *);
@@ -121,5 +121,5 @@
     bool (*)(cap_t *, void *), void *);
 
-extern errno_t cap_alloc(struct task *, cap_handle_t *);
+extern cap_handle_t cap_alloc(struct task *);
 extern void cap_publish(struct task *, cap_handle_t, kobject_t *);
 extern kobject_t *cap_unpublish(struct task *, cap_handle_t, kobject_type_t);
Index: kernel/generic/include/console/console.h
===================================================================
--- kernel/generic/include/console/console.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/include/console/console.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -71,5 +71,5 @@
 extern wchar_t getc(indev_t *indev);
 extern size_t gets(indev_t *indev, char *buf, size_t buflen);
-extern sys_errno_t sys_kio(int cmd, const void *buf, size_t size);
+extern sysarg_t sys_kio(int cmd, const void *buf, size_t size);
 
 extern void grab_console(void);
Index: kernel/generic/include/ddi/ddi.h
===================================================================
--- kernel/generic/include/ddi/ddi.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/include/ddi/ddi.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -55,20 +55,20 @@
 extern void ddi_parea_register(parea_t *);
 
-extern sys_errno_t sys_physmem_map(uintptr_t, size_t, unsigned int, void *,
+extern sysarg_t sys_physmem_map(uintptr_t, size_t, unsigned int, void *,
     uintptr_t);
-extern sys_errno_t sys_physmem_unmap(uintptr_t);
+extern sysarg_t sys_physmem_unmap(uintptr_t);
 
-extern sys_errno_t sys_dmamem_map(size_t, unsigned int, unsigned int, void *,
+extern sysarg_t sys_dmamem_map(size_t, unsigned int, unsigned int, void *,
     void *, uintptr_t);
-extern sys_errno_t sys_dmamem_unmap(uintptr_t, size_t, unsigned int);
+extern sysarg_t sys_dmamem_unmap(uintptr_t, size_t, unsigned int);
 
-extern sys_errno_t sys_iospace_enable(ddi_ioarg_t *);
-extern sys_errno_t sys_iospace_disable(ddi_ioarg_t *);
+extern sysarg_t sys_iospace_enable(ddi_ioarg_t *);
+extern sysarg_t sys_iospace_disable(ddi_ioarg_t *);
 
 /*
  * Interface to be implemented by all architectures.
  */
-extern errno_t ddi_iospace_enable_arch(task_t *, uintptr_t, size_t);
-extern errno_t ddi_iospace_disable_arch(task_t *, uintptr_t, size_t);
+extern int ddi_iospace_enable_arch(task_t *, uintptr_t, size_t);
+extern int ddi_iospace_disable_arch(task_t *, uintptr_t, size_t);
 
 #endif
Index: kernel/generic/include/errno.h
===================================================================
--- kernel/generic/include/errno.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/include/errno.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -36,5 +36,4 @@
 #define KERN_ERRNO_H_
 
-#include <_bits/errno.h>
 #include <abi/errno.h>
 
Index: kernel/generic/include/func.h
===================================================================
--- kernel/generic/include/func.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
+++ kernel/generic/include/func.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -0,0 +1,47 @@
+/*
+ * Copyright (c) 2001-2004 Jakub Jermar
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup generic
+ * @{
+ */
+/** @file
+ */
+
+#ifndef KERN_FUNC_H_
+#define KERN_FUNC_H_
+
+#include <atomic.h>
+
+extern atomic_t haltstate;
+
+extern void halt(void) __attribute__((noreturn));
+
+#endif
+
+/** @}
+ */
Index: kernel/generic/include/interrupt.h
===================================================================
--- kernel/generic/include/interrupt.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/include/interrupt.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -61,7 +61,7 @@
 
 extern void fault_from_uspace(istate_t *, const char *, ...)
-    _HELENOS_PRINTF_ATTRIBUTE(2, 3);
+    PRINTF_ATTRIBUTE(2, 3);
 extern void fault_if_from_uspace(istate_t *, const char *, ...)
-    _HELENOS_PRINTF_ATTRIBUTE(2, 3);
+    PRINTF_ATTRIBUTE(2, 3);
 extern istate_t *istate_get(thread_t *);
 extern iroutine_t exc_register(unsigned int, const char *, bool, iroutine_t);
Index: kernel/generic/include/ipc/event.h
===================================================================
--- kernel/generic/include/ipc/event.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/include/ipc/event.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -95,12 +95,12 @@
 	event_task_notify((t), (e), (m), (a1), (a2), (a3), (a4), (a5))
 
-extern errno_t event_notify(event_type_t, bool, sysarg_t, sysarg_t, sysarg_t,
+extern int event_notify(event_type_t, bool, sysarg_t, sysarg_t, sysarg_t,
     sysarg_t, sysarg_t);
-extern errno_t event_task_notify(struct task *, event_task_type_t, bool, sysarg_t, sysarg_t,
+extern int event_task_notify(struct task *, event_task_type_t, bool, sysarg_t, sysarg_t,
     sysarg_t, sysarg_t, sysarg_t);
 
-extern sys_errno_t sys_ipc_event_subscribe(sysarg_t, sysarg_t);
-extern sys_errno_t sys_ipc_event_unsubscribe(sysarg_t);
-extern sys_errno_t sys_ipc_event_unmask(sysarg_t);
+extern sysarg_t sys_ipc_event_subscribe(sysarg_t, sysarg_t);
+extern sysarg_t sys_ipc_event_unsubscribe(sysarg_t);
+extern sysarg_t sys_ipc_event_unmask(sysarg_t);
 
 #endif
Index: kernel/generic/include/ipc/ipc.h
===================================================================
--- kernel/generic/include/ipc/ipc.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/include/ipc/ipc.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -110,6 +110,4 @@
 	/** User-defined label */
 	sysarg_t label;
-	/** Capability handle */
-	cap_handle_t cap_handle;
 } ipc_data_t;
 
@@ -186,8 +184,8 @@
 extern void ipc_call_release(call_t *);
 
-extern errno_t ipc_call_sync(phone_t *, call_t *);
-extern errno_t ipc_call(phone_t *, call_t *);
+extern int ipc_call_sync(phone_t *, call_t *);
+extern int ipc_call(phone_t *, call_t *);
 extern call_t *ipc_wait_for_call(answerbox_t *, uint32_t, unsigned int);
-extern errno_t ipc_forward(call_t *, phone_t *, answerbox_t *, unsigned int);
+extern int ipc_forward(call_t *, phone_t *, answerbox_t *, unsigned int);
 extern void ipc_answer(answerbox_t *, call_t *);
 extern void _ipc_answer_free_call(call_t *, bool);
@@ -195,10 +193,10 @@
 extern void ipc_phone_init(phone_t *, struct task *);
 extern bool ipc_phone_connect(phone_t *, answerbox_t *);
-extern errno_t ipc_phone_hangup(phone_t *);
+extern int ipc_phone_hangup(phone_t *);
 
 extern void ipc_answerbox_init(answerbox_t *, struct task *);
 
 extern void ipc_cleanup(void);
-extern void ipc_backsend_err(phone_t *, call_t *, errno_t);
+extern void ipc_backsend_err(phone_t *, call_t *, sysarg_t);
 extern void ipc_answerbox_slam_phones(answerbox_t *, bool);
 extern void ipc_cleanup_call_list(answerbox_t *, list_t *);
Index: kernel/generic/include/ipc/ipcrsc.h
===================================================================
--- kernel/generic/include/ipc/ipcrsc.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/include/ipc/ipcrsc.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -40,5 +40,5 @@
 #include <cap/cap.h>
 
-extern errno_t phone_alloc(task_t *, cap_handle_t *);
+extern cap_handle_t phone_alloc(task_t *);
 extern bool phone_connect(cap_handle_t, answerbox_t *);
 extern void phone_dealloc(cap_handle_t);
Index: kernel/generic/include/ipc/irq.h
===================================================================
--- kernel/generic/include/ipc/irq.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/include/ipc/irq.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -51,7 +51,6 @@
 extern void ipc_irq_top_half_handler(irq_t *);
 
-extern errno_t ipc_irq_subscribe(answerbox_t *, inr_t, sysarg_t, irq_code_t *,
-    cap_handle_t *);
-extern errno_t ipc_irq_unsubscribe(answerbox_t *, int);
+extern int ipc_irq_subscribe(answerbox_t *, inr_t, sysarg_t, irq_code_t *);
+extern int ipc_irq_unsubscribe(answerbox_t *, int);
 
 /*
Index: kernel/generic/include/ipc/kbox.h
===================================================================
--- kernel/generic/include/ipc/kbox.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/include/ipc/kbox.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -50,5 +50,5 @@
 } kbox_t;
 
-extern errno_t ipc_connect_kbox(task_id_t, cap_handle_t *);
+extern int ipc_connect_kbox(task_id_t);
 extern void ipc_kbox_cleanup(void);
 
Index: kernel/generic/include/ipc/sysipc.h
===================================================================
--- kernel/generic/include/ipc/sysipc.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/include/ipc/sysipc.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -40,24 +40,34 @@
 #include <typedefs.h>
 
-extern errno_t ipc_req_internal(int, ipc_data_t *, sysarg_t);
+extern int ipc_req_internal(int, ipc_data_t *, sysarg_t);
 
-extern sys_errno_t sys_ipc_call_async_fast(sysarg_t, sysarg_t, sysarg_t,
+extern sysarg_t sys_ipc_call_async_fast(sysarg_t, sysarg_t, sysarg_t,
     sysarg_t, sysarg_t, sysarg_t);
-extern sys_errno_t sys_ipc_call_async_slow(sysarg_t, ipc_data_t *, sysarg_t);
-extern sys_errno_t sys_ipc_answer_fast(sysarg_t, sysarg_t, sysarg_t, sysarg_t,
+extern sysarg_t sys_ipc_call_async_slow(sysarg_t, ipc_data_t *, sysarg_t);
+extern sysarg_t sys_ipc_answer_fast(sysarg_t, sysarg_t, sysarg_t, sysarg_t,
     sysarg_t, sysarg_t);
-extern sys_errno_t sys_ipc_answer_slow(sysarg_t, ipc_data_t *);
-extern sys_errno_t sys_ipc_wait_for_call(ipc_data_t *, uint32_t, unsigned int);
-extern sys_errno_t sys_ipc_poke(void);
-extern sys_errno_t sys_ipc_forward_fast(sysarg_t, sysarg_t, sysarg_t, sysarg_t,
+extern sysarg_t sys_ipc_answer_slow(sysarg_t, ipc_data_t *);
+extern sysarg_t sys_ipc_wait_for_call(ipc_data_t *, uint32_t, unsigned int);
+extern sysarg_t sys_ipc_poke(void);
+extern sysarg_t sys_ipc_forward_fast(sysarg_t, sysarg_t, sysarg_t, sysarg_t,
     sysarg_t, unsigned int);
-extern sys_errno_t sys_ipc_forward_slow(sysarg_t, sysarg_t, ipc_data_t *,
+extern sysarg_t sys_ipc_forward_slow(sysarg_t, sysarg_t, ipc_data_t *,
     unsigned int);
-extern sys_errno_t sys_ipc_hangup(sysarg_t);
+extern sysarg_t sys_ipc_hangup(sysarg_t);
 
-extern sys_errno_t sys_ipc_irq_subscribe(inr_t, sysarg_t, irq_code_t *, cap_handle_t *);
-extern sys_errno_t sys_ipc_irq_unsubscribe(sysarg_t);
+extern sysarg_t sys_ipc_irq_subscribe(inr_t, sysarg_t, irq_code_t *);
+extern sysarg_t sys_ipc_irq_unsubscribe(sysarg_t);
 
-extern sys_errno_t sys_ipc_connect_kbox(task_id_t *, cap_handle_t *);
+#ifdef __32_BITS__
+
+extern sysarg_t sys_ipc_connect_kbox(sysarg64_t *);
+
+#endif  /* __32_BITS__ */
+
+#ifdef __64_BITS__
+
+extern sysarg_t sys_ipc_connect_kbox(sysarg_t);
+
+#endif  /* __64_BITS__ */
 
 #endif
Index: kernel/generic/include/ipc/sysipc_ops.h
===================================================================
--- kernel/generic/include/ipc/sysipc_ops.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/include/ipc/sysipc_ops.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -40,7 +40,11 @@
 #define SYSIPC_OP(op, call, ...) \
 	({ \
-		sysipc_ops_t *ops = sysipc_ops_get((call)->request_method); \
-		assert(ops->op); \
-		ops->op((call), ##__VA_ARGS__); \
+		int rc = EOK; \
+		\
+		sysipc_ops_t *ops; \
+		ops = sysipc_ops_get((call)->request_method); \
+		if (ops->op) \
+			rc = ops->op((call), ##__VA_ARGS__); \
+		rc; \
 	})
 
@@ -90,5 +94,5 @@
 	 * Invoked on:		all calls
 	 */
-	errno_t (*request_preprocess)(call_t *, phone_t *);
+	int (* request_preprocess)(call_t *, phone_t *);
 
 	/**
@@ -101,6 +105,6 @@
 	 *			_ipc_answer_free_call()
 	 * Invoked on:		all forgotten calls
-	 */
-	errno_t (*request_forget)(call_t *);
+	 */	
+	int (* request_forget)(call_t *);
 
 	/**
@@ -111,6 +115,6 @@
 	 * Races with:		request_forget()
 	 * Invoked on:		all calls delivered to the callee
-	 */
-	int (*request_process)(call_t *, answerbox_t *);
+	 */	
+	int (* request_process)(call_t *, answerbox_t *);
 
 	/**
@@ -123,5 +127,5 @@
 	 * Invoked on:		all forgotten calls
 	 */
-	errno_t (*answer_cleanup)(call_t *, ipc_data_t *);
+	int (* answer_cleanup)(call_t *, ipc_data_t *);
 
 	/**
@@ -134,5 +138,5 @@
 	 * Invoked on:		all answered calls
 	 */
-	errno_t (*answer_preprocess)(call_t *, ipc_data_t *);
+	int (* answer_preprocess)(call_t *, ipc_data_t *);
 
 	/**
@@ -144,15 +148,15 @@
 	 * Invoked on:		all answered calls
 	 */
-	errno_t (*answer_process)(call_t *);
+	int (* answer_process)(call_t *);
 } sysipc_ops_t;
 
 extern sysipc_ops_t *sysipc_ops_get(sysarg_t);
 
-extern errno_t null_request_preprocess(call_t *, phone_t *);
-extern errno_t null_request_forget(call_t *);
+extern int null_request_preprocess(call_t *, phone_t *);
+extern int null_request_forget(call_t *);
 extern int null_request_process(call_t *, answerbox_t *);
-extern errno_t null_answer_cleanup(call_t *, ipc_data_t *);
-extern errno_t null_answer_preprocess(call_t *, ipc_data_t *);
-extern errno_t null_answer_process(call_t *);
+extern int null_answer_cleanup(call_t *, ipc_data_t *);
+extern int null_answer_preprocess(call_t *, ipc_data_t *);
+extern int null_answer_process(call_t *);
 
 #endif
Index: kernel/generic/include/ipc/sysipc_priv.h
===================================================================
--- kernel/generic/include/ipc/sysipc_priv.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/include/ipc/sysipc_priv.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -38,5 +38,5 @@
 #include <ipc/ipc.h>
 
-extern errno_t answer_preprocess(call_t *, ipc_data_t *);
+extern int answer_preprocess(call_t *, ipc_data_t *);
 
 #endif
Index: kernel/generic/include/log.h
===================================================================
--- kernel/generic/include/log.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/include/log.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -36,5 +36,4 @@
 #define KERN_LOG_H_
 
-#include <errno.h>
 #include <stdarg.h>
 #include <stddef.h>
@@ -48,10 +47,10 @@
 extern int log_vprintf(const char *, va_list);
 extern int log_printf(const char *, ...)
-    _HELENOS_PRINTF_ATTRIBUTE(1, 2);
+    PRINTF_ATTRIBUTE(1, 2);
 extern int log(log_facility_t, log_level_t, const char *, ...)
-    _HELENOS_PRINTF_ATTRIBUTE(3, 4);
+    PRINTF_ATTRIBUTE(3, 4);
 
-extern sys_errno_t sys_klog(sysarg_t, void *buf, size_t size,
-    sysarg_t level, size_t *uspace_nread);
+extern sysarg_t sys_klog(sysarg_t, void *buf, size_t size,
+    sysarg_t level);
 
 #endif /* KERN_LOG_H_ */
Index: kernel/generic/include/mm/as.h
===================================================================
--- kernel/generic/include/mm/as.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/include/mm/as.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -268,9 +268,9 @@
 extern as_area_t *as_area_create(as_t *, unsigned int, size_t, unsigned int,
     mem_backend_t *, mem_backend_data_t *, uintptr_t *, uintptr_t);
-extern errno_t as_area_destroy(as_t *, uintptr_t);
-extern errno_t as_area_resize(as_t *, uintptr_t, size_t, unsigned int);
-extern errno_t as_area_share(as_t *, uintptr_t, size_t, as_t *, unsigned int,
+extern int as_area_destroy(as_t *, uintptr_t);
+extern int as_area_resize(as_t *, uintptr_t, size_t, unsigned int);
+extern int as_area_share(as_t *, uintptr_t, size_t, as_t *, unsigned int,
     uintptr_t *, uintptr_t);
-extern errno_t as_area_change_flags(as_t *, unsigned int, uintptr_t);
+extern int as_area_change_flags(as_t *, unsigned int, uintptr_t);
 
 extern unsigned int as_area_get_flags(as_area_t *);
@@ -283,5 +283,5 @@
 
 #ifndef as_constructor_arch
-extern errno_t as_constructor_arch(as_t *, unsigned int);
+extern int as_constructor_arch(as_t *, unsigned int);
 #endif /* !def as_constructor_arch */
 
@@ -291,5 +291,5 @@
 
 #ifndef as_create_arch
-extern errno_t as_create_arch(as_t *, unsigned int);
+extern int as_create_arch(as_t *, unsigned int);
 #endif /* !def as_create_arch */
 
@@ -311,7 +311,7 @@
 extern sysarg_t sys_as_area_create(uintptr_t, size_t, unsigned int, uintptr_t,
     as_area_pager_info_t *);
-extern sys_errno_t sys_as_area_resize(uintptr_t, size_t, unsigned int);
-extern sys_errno_t sys_as_area_change_flags(uintptr_t, unsigned int);
-extern sys_errno_t sys_as_area_destroy(uintptr_t);
+extern sysarg_t sys_as_area_resize(uintptr_t, size_t, unsigned int);
+extern sysarg_t sys_as_area_change_flags(uintptr_t, unsigned int);
+extern sysarg_t sys_as_area_destroy(uintptr_t);
 
 /* Introspection functions. */
Index: kernel/generic/include/mm/page.h
===================================================================
--- kernel/generic/include/mm/page.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/include/mm/page.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -46,9 +46,9 @@
 /** Operations to manipulate page mappings. */
 typedef struct {
-	void (*mapping_insert)(as_t *, uintptr_t, uintptr_t, unsigned int);
-	void (*mapping_remove)(as_t *, uintptr_t);
-	bool (*mapping_find)(as_t *, uintptr_t, bool, pte_t *);
-	void (*mapping_update)(as_t *, uintptr_t, bool, pte_t *);
-	void (*mapping_make_global)(uintptr_t, size_t);
+	void (* mapping_insert)(as_t *, uintptr_t, uintptr_t, unsigned int);
+	void (* mapping_remove)(as_t *, uintptr_t);
+	bool (* mapping_find)(as_t *, uintptr_t, bool, pte_t *);
+	void (* mapping_update)(as_t *, uintptr_t, bool, pte_t *);
+	void (* mapping_make_global)(uintptr_t, size_t);
 } page_mapping_operations_t;
 
@@ -67,6 +67,6 @@
 extern void page_table_destroy(pte_t *);
 
-extern errno_t page_find_mapping(uintptr_t, uintptr_t *);
-extern sys_errno_t sys_page_find_mapping(uintptr_t, uintptr_t *);
+extern int page_find_mapping(uintptr_t, uintptr_t *);
+extern sysarg_t sys_page_find_mapping(uintptr_t, uintptr_t *);
 
 #endif
Index: kernel/generic/include/mm/slab.h
===================================================================
--- kernel/generic/include/mm/slab.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/include/mm/slab.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -94,5 +94,5 @@
 	size_t size;
 	
-	errno_t (*constructor)(void *obj, unsigned int kmflag);
+	int (*constructor)(void *obj, unsigned int kmflag);
 	size_t (*destructor)(void *obj);
 	
@@ -124,5 +124,5 @@
 
 extern slab_cache_t *slab_cache_create(const char *, size_t, size_t,
-    errno_t (*)(void *, unsigned int), size_t (*)(void *), unsigned int);
+    int (*)(void *, unsigned int), size_t (*)(void *), unsigned int);
 extern void slab_cache_destroy(slab_cache_t *);
 
Index: kernel/generic/include/panic.h
===================================================================
--- kernel/generic/include/panic.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/include/panic.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -66,5 +66,5 @@
 extern void panic_common(panic_category_t, struct istate *, int,
     uintptr_t, const char *, ...) __attribute__ ((noreturn))
-    _HELENOS_PRINTF_ATTRIBUTE(5, 6);
+    PRINTF_ATTRIBUTE(5, 6);
 
 #endif
Index: kernel/generic/include/print.h
===================================================================
--- kernel/generic/include/print.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/include/print.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -44,7 +44,7 @@
 extern int puts(const char *s);
 extern int printf(const char *fmt, ...)
-    _HELENOS_PRINTF_ATTRIBUTE(1, 2);
+    PRINTF_ATTRIBUTE(1, 2);
 extern int snprintf(char *str, size_t size, const char *fmt, ...)
-    _HELENOS_PRINTF_ATTRIBUTE(3, 4);
+    PRINTF_ATTRIBUTE(3, 4);
 
 extern int vprintf(const char *fmt, va_list ap);
Index: kernel/generic/include/printf/verify.h
===================================================================
--- kernel/generic/include/printf/verify.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/include/printf/verify.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -36,20 +36,20 @@
 #define KERN_PRINTF_VERIFY_H_
 
-#ifndef _HELENOS_NVERIFY_PRINTF
+#ifndef NVERIFY_PRINTF
 
 #ifdef __clang__
-#define _HELENOS_PRINTF_ATTRIBUTE(start, end) \
+#define PRINTF_ATTRIBUTE(start, end) \
 	__attribute__((format(__printf__, start, end)))
 #else
-#define _HELENOS_PRINTF_ATTRIBUTE(start, end) \
+#define PRINTF_ATTRIBUTE(start, end) \
 	__attribute__((format(gnu_printf, start, end)))
 #endif
 
 
-#else /* _HELENOS_NVERIFY_PRINTF */
+#else /* NVERIFY_PRINTF */
 
-#define _HELENOS_PRINTF_ATTRIBUTE(start, end)
+#define PRINTF_ATTRIBUTE(start, end)
 
-#endif /* _HELENOS_NVERIFY_PRINTF */
+#endif /* NVERIFY_PRINTF */
 
 #endif
